using System;
namespace MATRIXDEC
{
	public class MATRIX
	{
		public static byte[] sec1 = new byte[]
		{
			16,
			64,
			128,
			32,
			2,
			4,
			8,
			1
		};
		public static byte[] sec2 = new byte[]
		{
			32,
			64,
			16,
			128,
			1,
			4,
			8,
			2
		};
		public static byte[] MarEnc(byte[] a)
		{
			int[,] a2 = MATRIX.getmatrix(a);
			int[,] m = MATRIX.multi(a2, MATRIX.getmatrix(MATRIX.sec1));
			return MATRIX.getbytearr(m);
		}
		public static byte[] MarDec(byte[] d)
		{
			int[,] a = MATRIX.getmatrix(d);
			int[,] m = MATRIX.multi(a, MATRIX.reve(MATRIX.getmatrix(MATRIX.sec1)));
			return MATRIX.getbytearr(m);
		}
		public static byte[] MarEnc1(byte[] a)
		{
			int[,] a2 = MATRIX.getmatrix(a);
			int[,] m = MATRIX.multi(a2, MATRIX.getmatrix(MATRIX.sec2));
			return MATRIX.getbytearr(m);
		}
		public static byte[] MarDec1(byte[] d)
		{
			int[,] a = MATRIX.getmatrix(d);
			int[,] m = MATRIX.multi(a, MATRIX.reve(MATRIX.getmatrix(MATRIX.sec2)));
			return MATRIX.getbytearr(m);
		}
		public static int getbit(byte b, int index)
		{
			b = (byte)(b << index);
			b = (byte)(b >> 7);
			return (int)b;
		}
		public static string bytearr2string(byte[] d)
		{
			string text = "";
			for (int i = 0; i < d.Length; i++)
			{
				string arg_1C_0 = text;
				int num = (int)d[i];
				text = arg_1C_0 + num.ToString("X2");
			}
			return text;
		}
		public static int[] getintarr(byte b)
		{
			int[] array = new int[8];
			for (int i = 0; i < 8; i++)
			{
				array[i] = MATRIX.getbit(b, i);
			}
			return array;
		}
		public static int[,] getmatrix(byte[] b)
		{
			int[,] array = new int[8, 8];
			int[] array2 = new int[8];
			for (int i = 0; i < 8; i++)
			{
				array2 = MATRIX.getintarr(b[i]);
				for (int j = 0; j < 8; j++)
				{
					array[i, j] = array2[j];
				}
			}
			return array;
		}
		public static byte[] getbytearr(int[,] m)
		{
			byte[] array = new byte[8];
			for (int i = 0; i < 8; i++)
			{
				array[i] = 0;
				int num = 1;
				for (int j = 0; j < 8; j++)
				{
					byte[] expr_1F_cp_0 = array;
					int expr_1F_cp_1 = i;
					expr_1F_cp_0[expr_1F_cp_1] += (byte)(m[i, 7 - j] * num);
					num *= 2;
				}
			}
			return array;
		}
		public static string bytetostring(byte[] d)
		{
			string text = "";
			for (int i = 0; i < d.Length; i++)
			{
				string arg_1C_0 = text;
				int num = (int)d[i];
				text = arg_1C_0 + num.ToString("X2");
			}
			return text;
		}
		public static byte[] stringtobyte(string s)
		{
			byte[] result;
			if (s.Length == 8)
			{
				result = MATRIX.string8tobyte(s);
			}
			else
			{
				if (s.Length == 16)
				{
					result = MATRIX.string16tobyte(s);
				}
				else
				{
					result = null;
				}
			}
			return result;
		}
		private static byte[] string8tobyte(string s)
		{
			byte[] array = new byte[8];
			for (int i = 0; i < 8; i++)
			{
				array[i] = byte.Parse(string.Concat(s[i]));
			}
			return array;
		}
		private static byte[] string16tobyte(string ss)
		{
			byte[] array = new byte[8];
			for (int i = 0; i < 16; i += 2)
			{
				string value = ss.Substring(i, 2);
				array[i / 2] = (byte)Convert.ToInt32(value, 16);
			}
			return array;
		}
		public static int[,] reve(int[,] a)
		{
			int[,] array = new int[8, 8];
			for (int i = 0; i < 8; i++)
			{
				for (int j = 0; j < 8; j++)
				{
					array[i, j] = a[j, i];
				}
			}
			return array;
		}
		public static int[,] multi(int[,] a, int[,] b)
		{
			int[,] array = new int[8, 8];
			for (int i = 0; i < 8; i++)
			{
				for (int j = 0; j < 8; j++)
				{
					array[i, j] = 0;
					for (int k = 0; k < 8; k++)
					{
						array[i, j] += a[i, k] * b[k, j];
					}
				}
			}
			return array;
		}
	}
}
